<template>
  <GManageTable
    :level="level"
    :card="card"
    :optional="optional"
    :wiki-entry="wikiEntry"
    :i18n-base="i18nBase"
    v-bind="$attrs"
    :headers="headers"
    :items="value[editedKey]"
    :get-new-item="getNewItem"
    use-wrapper
    @deleteElement="$emit('delete')"
    @create="create"
    @edit="edit"
    @remove="remove"
  >
    <template #form="{ item, updateAvailableElements }">
      <Constant
        v-if="editedKey === 'constant'"
        v-model="item.value"
        :update-available-elements="updateAvailableElements"
      />
      <Real
        v-else-if="editedKey === 'real'"
        v-model="item.value"
        :update-available-elements="updateAvailableElements"
      />
      <RealListXMLList
        v-else-if="editedKey === 'realListXMLList'"
        v-model="item.value"
        :update-available-elements="updateAvailableElements"
      />
    </template>

    <template #[`item.value`]="{ item }">
      <div
        v-for="(valueString, index) of getDisplayedUnitAndValue(item).values"
        :key="index"
        class="text-truncate default-max-width"
      >
        {{ valueString }}<br />
      </div>
    </template>
    <template #[`item.unit`]="{ item }">
      {{ getDisplayedUnitAndValue(item).units.join("\n") }}
    </template>
  </GManageTable>
</template>

<script>
import {
  RealListXMLListType,
  RealQuantityType,
  ConstantQuantityType,
} from "@d-ptb/dcc-js";
import { removeFromArray } from "~/assets/util/general";
import { getDisplayedUnitAndValue } from "~/assets/util/dccUtil";
import GManageTable from "~/components/App/Common/ManagementTable/GManageTable";
import Constant from "~/components/D-SI/Constant";
import Real from "~/components/D-SI/Real";
import RealListXMLList from "~/components/D-SI/RealListXMLList";

export default {
  name: "Hybrid",
  components: { RealListXMLList, Real, Constant, GManageTable },
  props: {
    value: Object,
    card: Boolean,
    level: String,
    optional: {
      type: Boolean,
      default: false,
    },
    wikiEntry: {
      type: String,
      default: "dsi",
    },
  },
  computed: {
    editedKey() {
      if (this.value.realListXMLList) return "realListXMLList";
      else if (this.value.constant) return "constant";
      else return "real";
    },
    editedCtor() {
      switch (this.editedKey) {
        case "realListXMLList":
          return RealListXMLListType;
        case "constant":
          return ConstantQuantityType;
        default:
          return RealQuantityType;
      }
    },
    customRules() {
      return [
        () =>
          this.value[this.editedKey].length > 0 ||
          this.$t(`${this.i18nBase}.empty`),
      ];
    },
    i18nBase() {
      return `d_si.hybrid.${this.editedKey}`;
    },
    headers() {
      return [
        {
          text: this.$t(`${this.i18nBase}.value`),
          value: "value",
        },
        {
          text: this.$t(`${this.i18nBase}.unit`),
          value: "unit",
        },
      ];
    },
  },
  methods: {
    remove(item) {
      removeFromArray(this.value[this.editedKey], item);
    },
    getNewItem() {
      return Object.create(this.editedCtor);
    },
    create(item) {
      this.value[this.editedKey].push(item);
    },
    edit(item, index) {
      Object.assign(this.value[this.editedKey][index], item);
    },
    getDisplayedUnitAndValue,
  },
};
</script>
